#!/bin/bash

# Copyright (C) 2007, 2008, 2009 Google Inc.
# Copyright (c) 2014 Jan Rękorajski <baggins@pld-linux.org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.

set -e

. common.sh

# If the target device is not a real block device we'll first losetup it.
# This is needed for file disks.
if [ ! -b $blockdev ]; then
	ORIGINAL_BLOCKDEV=$blockdev
	blockdev=$(losetup -sf $blockdev)
	CLEANUP+=("losetup -d $blockdev")
fi

if [ "$PARTITION_STYLE" = "none" ]; then
	filesystem_dev=$blockdev
elif [ "$PARTITION_STYLE" = "msdos" ]; then
	# Create one big partition, and make it bootable
	format_disk0 $blockdev
	filesystem_dev=$(map_disk0 $blockdev)
	CLEANUP+=("unmap_disk0 $blockdev")
else
	echo "Unknown partition style $PARTITION_STYLE"
	exit 1
fi

case $OSP_FILESYSTEM in
	ext*)
		mke2fs -Fjqt $OSP_FILESYSTEM $filesystem_dev
		;;
	xfs)
		mkfs.xfs -fq $filesystem_dev
		;;
	*)
		echo "Invalid value '$OSP_FILESYSTEM' for the filesystem parameter" 1>&2
		exit 1
		;;
esac

root_uuid=$($VOL_ID $filesystem_dev )

if [ -n "$swapdev" ]; then
	mkswap $swapdev
	swap_uuid=$($VOL_ID $swapdev || true )
fi

TMPDIR=`mktemp -d` || exit 1
CLEANUP+=("rmdir $TMPDIR")

mount $filesystem_dev $TMPDIR
CLEANUP+=("umount $TMPDIR")

case $OSP_FILESYSTEM in
	ext*)
		( cd $TMPDIR; restore -r -y -f - )
		;;
	xfs)
		( xfsrestore -F - $TMPDIR )
		;;
	*)
esac

# Fix /etc/fstab with the new volumes' UUIDs
if [ -e $TMPDIR/etc/fstab ]; then
	ROOT_LINE="UUID=$root_uuid	/	$OSP_FILESYSTEM	defaults	0 1"
	if [ -n "$swapdev" -a -n "$swap_uuid" ]; then
		SWAP_LINE="UUID=$swap_uuid  swap  swap  defaults  0  0"
		cat $TMPDIR/etc/fstab | \
			sed -re "s#^(/dev/sda|UUID=[a-f0-9-]+)\s+/\s+.*\$#$ROOT_LINE#" \
			-e "s#^(/dev/sdb|UUID=[a-f0-9-]+)\s+swap\s+.*\$#$SWAP_LINE#" \
			> $TMPDIR/etc/fstab.new
	else
		cat $TMPDIR/etc/fstab | \
			sed -re "s#^(/dev/sda|UUID=[a-f0-9-]+)\s+/\s+.*\$#$ROOT_LINE#" \
			> $TMPDIR/etc/fstab.new
	fi
	mv $TMPDIR/etc/fstab.new  $TMPDIR/etc/fstab
fi

# execute cleanups
cleanup
trap - EXIT

exit 0
